<%
'*************************************************************
'*  VB Script Authentication Class V1.0
'*
'*  Copyright (C) 2003, Neal Clark, Clark Multimedia
'*  http://www.clarkmultimedia.com
'*
'*  Suggestions and comments should be sent to:
'*
'*  info@clarkmultimedia.com
'*
'*  or by snail mail to:
'*
'*  Clark Multimedia
'*  2313 Boulder Ridge
'*  Whistler, BC, V0N 1B2
'*  Canada
'* 
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License as published by the Free Software Foundation; either
'*  version 2.1 of the License, or (at your option) any later version.
'* 
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*  
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'*
'*  MODIFICATION HISTORY:
'*  1.0    21-Feb-2003 - Neal Clark (info@clarkmultimedia.com) - Initial Version (VB/ASP code)
'*
'*  TODO:
'*************************************************************

class authentication
' ************ Declare Private Varialbes ************
	private m_authStat
	private m_permissions
	
	private m_userName
	private m_password
	private m_accessGroup
	
' ************ Initialize Class ************
	private sub Class_Initialize()
		m_authStat = false
		set m_permissions = new Vector
		m_authStat = session(LOGIN_PARAM)
		m_userName = session(LOGIN_USER_PARAM)
		m_accessGroup = session(LOGIN_GROUP)
  	end sub

' ************ Public Properties ************

'*************************************************************
'* POST: returns true if the user is authenticated
'*************************************************************
	public property get authenticated()
		authenticated = m_authStat
	end property

	
' ************ Public Functions ************

'*************************************************************
'* POST: add a directory to the list of accessable dirs
'*************************************************************
	public sub addPermission(byVal str)
		m_permissions.add(lcase(str))
	end sub

'*************************************************************
'* POST: grants access to the specified dir
'*************************************************************	
	public sub removePermission(byVal str)
		dim pos
		pos = m_permissions.indexOf(str)
		
		if pos >= 0 then
			m_permissions.remove(pos)
		end if
	end sub
	
	'*************************************************************
'* POST: chechs if user has been granted the specified permission
'*****************************************************************
	public function checkPermission(byVal str)
		if m_permissions.indexOf(str) >= 0 then
			checkPermission = true
		else
			checkPermission = false
		end if
	end function

'*************************************************************
'* POST: authenticates the user using the specified username
'*		 and password
'*************************************************************
	public sub login(byVal userName, byVal password)
		m_userName = userName
		m_password = password
		
		dim loginRs
		set loginRs = Server.CreateObject("ADODB.Recordset")
		
		dim strSql
		strSql = " SELECT UserID, AccessGroup FROM LOGIN "&_
				 " WHERE UserName = '" & m_userName & "' AND " &_
				 " Password = '" & m_password & "'"
		
		loginRs.Open strSql, db_Conn, adOpenForwardOnly, adLockReadOnly, adCmdText
		
		if not loginRs.EOF then
			m_accessGroup = loginRs.fields.item("AccessGroup").value
			session(LOGIN_PARAM) = true
			session(LOGIN_USER_PARAM) = m_userName
			session(LOGIN_GROUP) = m_accessGroup
			
			m_authStat = true
		else
			m_authStat = false
			logout()
		end if

	end sub

'*************************************************************
'* POST: logs the user out of the system
'*************************************************************	
	public sub logout()
		m_userName = ""
		m_accessGroup = ""
		m_authStat = false
		session(LOGIN_PARAM) = false
		session(LOGIN_USER_PARAM) = ""
		session(LOGIN_GROUP) = ""
	end sub

'*************************************************************
'* POST: returns the access group this user belongs to
'*************************************************************
	public property get accessGroup()
		accessGroup = m_accessGroup
	end property

'*************************************************************
'* POST: returns username of the authenticated user
'*************************************************************	
	public property get userName()
		userName = m_userName
	end property

' ************ Private Functions ************
	
end class
%>