<%
'*************************************************************
'*  VB Script Calendar Class V1.0
'*
'*  Copyright (C) 2003, Neal Clark, Clark Multimedia
'*  http://www.clarkmultimedia.com
'*
'*  Suggestions and comments should be sent to:
'*
'*  info@clarkmultimedia.com
'*
'*  or by snail mail to:
'*
'*  Clark Multimedia
'*  2313 Boulder Ridge
'*  Whistler, BC, V0N 1B2
'*  Canada
'* 
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License as published by the Free Software Foundation; either
'*  version 2.1 of the License, or (at your option) any later version.
'* 
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*  
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'*
'*  MODIFICATION HISTORY:
'*  1.0    21-Feb-2003 - Neal Clark (info@clarkmultimedia.com) - Initial Version (VB/ASP code)
'*
'*  TODO:
'*************************************************************

class calendar
' ************ Declare Private Varialbes ************
	private dDate     ' Date we're displaying calendar for
	private iDate
	private fDate
	private iDIM	  ' Days in current month
	private iDOW      ' Day Of Week that month starts on
	private iCurrent  ' Variable we use to hold current day of month as we write table
	private iPosition ' Var
' ************ Declare Public Varialbes ************	
	
' ************ Initialize Class ************
	private sub Class_Initialize()
		iCurrent = 1
  	end sub
	
' ************ Private Functions ************
	private function dayCount(dateIn)
		select case month(dateIn)
			case 1, 3, 5, 7, 8, 10, 12
				dayCount = 31
			case 4, 6, 9, 11
				dayCount = 30
			case 2
				if IsDate("February 29, " & year(dateIn)) then
					dayCount = 29
				else
					dayCount = 28
				end if
		end select
	end function
	
	private function monthStart(dateIn)
		monthStart = WeekDay(CDate(month(dateIn) & "/1/" & year(dateIn)))
	end function
	
' ************ Public Properties ************
	public property let calendarDate(ByVal dateIn)
		if isDate(dateIn) then
			dDate = dateIn
			iDate = dDate
		else 
			dDate = date()
			iDate = dDate
		end if 
		
		iDIM = dayCount(dDate)
		iDOW = monthStart(dDate)
	end property
	
	public property get monthText()
		monthText = MonthName(month(dDate))
	end property
	
	public property get perviousMonth
		perviousMonth = dateAdd("m",-1,dDate)
	end property

	public property get nextMonth
		nextMonth = dateAdd("m",1,dDate)
	end property
	
	public property get more
		if dateDiff("d",fDate,iDate) < iDIM then
			more = true
		else
			more = false
		end if
	end property
	
	public property get today
		if dDate = iDate then
			today = true
		else
			today = false
		end if 
	end property
	
	public property get write
		if iPosition >= 0 and iPosition < iDIM then
			write = day(iDate)
		end if
	end property
	
	public property get date
		if iPosition >= 0 and iPosition < iDIM then
			date = iDate
		end if
	end property
	
' ************ Public Functions ************	
	public sub moveFirst()
		iDate = month(dDate) & "/" & 1 & "/" & year(dDate)
		fDate = iDate
		iPosition = 1 - iDOW
	end sub
	
	public sub moveNext()
		if iPosition >= 0 then
			iDate = dateAdd("d",1,iDate)
		end if
		iPosition = iPosition + 1
	end sub
' ************ Terminate Class ************	
  	private sub Class_Terminate()
	
  	end sub
	
end class
%>