<%
'*************************************************************
'*  VB Script Database Utility Classes V 2.2
'*
'*  Copyright (C) 2003, Neal Clark, Clark Multimedia
'*  http://www.clarkmultimedia.com
'*
'*  Suggestions and comments should be sent to:
'*
'*  info@clarkmultimedia.com
'* 
'*  This library is free software; you can redistribute it and/or
'*  modify it under the terms of the GNU Lesser General Public
'*  License as published by the Free Software Foundation; either
'*  version 2.1 of the License, or (at your option) any later version.
'* 
'*  This library is distributed in the hope that it will be useful,
'*  but WITHOUT ANY WARRANTY; without even the implied warranty of
'*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
'*  Lesser General Public License for more details.
'*  
'*  You should have received a copy of the GNU Lesser General Public
'*  License along with this library; if not, write to the Free Software
'*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'*
'*  MODIFICATION HISTORY:
'*  1.0    10-Feb-2002 - Neal Clark (info@clarkmultimedia.com) - Initial Version (VB/ASP code)
'*  2.0    21-June-2003 - Neal Clark (info@clarkmultimedia.com) 
'*		 - Addition of: Type specific addField methods
'*			addDateField(String name, Date value)
'*			addTextField(String name, String value)
'*			addNumberField(String name, Number value)
'*		- empty value support added
'*  2.2   04-December-2003 - Neal Clark (info@clarkmultimedia.com) 
'*      - fixed sql reserved words bug by surrounding field name with [fieldName]
'*
'*  TODO:
'*************************************************************

class db_update
' ************ Declare Private Varialbes ************
	private m_connString
	private strFields
	private first
	private strUpdate
' ************ Declare Public Varialbes ************	
	
' ************ Initialize Class ************
	private sub Class_Initialize()
		first = true
  	end sub
	
	public sub addNewField(fldName,fldValue)
		if first = true then
			strFields = "SET " & strFields & "[" & fldName & "]" & " = " & fldValue & " "
			first = false
		else
			strFields = strFields & ", " & "[" & fldName & "]" & " = " & fldValue & " "
		end if
	end sub
	
' ************ Private Functions ************	
	
' ************ Public Functions ************	
	public property let activeConnection(byVal strConnString)
		m_connString = strConnString
	end property
	
	public property get activeConnection()
		activeConnection = m_connString
	end property
	
	public sub addDateField(fldName,fldValue)
		if fldValue <> "" then
			addNewField fldName, "#" & fldValue & "#"
		end if
	end sub
	
	public sub addTextField(fldName,fldValue)
		if fldValue <> "" then
			addNewField fldName, "'" & replace(fldValue,"'","''") & "'"
		end if
	end sub
	
	public sub addNumberField(fldName,fldValue)
		if fldValue <> "" then
			addNewField fldName, fldValue
		end if
	end sub
	
	public sub execute(tblName,fldName,fldValue)
		dim objConn
		dim strSql
		dim strKeyValue
		
		if isDate(fldValue) then		
			strKeyValue = "#" & fldValue & "#"
		elseif isNumeric(fldValue) then
			strKeyValue = fldValue
		else
			strKeyValue = "'" & fldValue & "'"
		end if
		
		strSql = "UPDATE [" & tblName & "] " & strFields & " WHERE " & fldName & " = " & strKeyValue	
		set objConn = Server.CreateObject("ADODB.Command")
			objConn.activeconnection = m_connString
			objConn.CommandText = strSql
			objConn.execute 
		set objConn = nothing
	end sub
' ************ Terminate Class ************	
  	private sub Class_Terminate()
	
  	end sub
	
end class
%>
